/*

SteamerPackage - CAPE-OPEN steam/water property package
Copyright (C) 2010 Jasper van Baten

You can use this source code provided that
 - its use is for academic teaching or academic research purposes, and
 - its use is non-commercial, and
 - you will not distribute COM objects that use any of the CLSIDs in Steamer.idl
 - you properly acknowledge the author

For any other use, please contact jasper@amsterchem.com

For more information, see LICENSE.txt

*/



// Steamer.cpp : Implementation of DLL Exports.


#include "stdafx.h"
#include "resource.h"
#include "Steamer.h"
#include "Variant.h"

class CSteamerModule : public CAtlDllModuleT< CSteamerModule >
{
public :
	DECLARE_LIBID(LIBID_SteamerLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_STEAMER, "{8D3663F4-EE76-4201-A38E-4849ABB54300}")
};

CSteamerModule _AtlModule;


#ifdef _MANAGED
#pragma managed(push, off)
#endif

// DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	hInstance;
	switch (dwReason)
	 {case DLL_PROCESS_ATTACH:
	       //loading DLL, init values
	       InitializeCapeDoubleMissingValue();
	       break;
	 }
    return _AtlModule.DllMain(dwReason, lpReserved); 
}

#ifdef _MANAGED
#pragma managed(pop)
#endif




// Used to determine whether the DLL can be unloaded by OLE
STDAPI DllCanUnloadNow(void)
{
    return _AtlModule.DllCanUnloadNow();
}


// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}


// DllRegisterServer - Adds entries to the system registry
STDAPI DllRegisterServer(void)
{
    // registers object
	TCHAR szTemp[20];
	HKEY key;
	if (RegOpenKeyEx(HKEY_CURRENT_USER,L"Software\\COCO",0,KEY_READ,&key)==ERROR_SUCCESS)
	 {DWORD type,size;
	  size=20;
	  if (RegQueryValueEx(key,L"CurrentUser",0,&type,(LPBYTE)szTemp,&size)==ERROR_SUCCESS)
	   if (lstrcmpi(szTemp,L"1")==0)
	    AtlSetPerUserRegistration(TRUE); 
	  RegCloseKey(key);
	 }
    HRESULT hr = _AtlModule.DllRegisterServer(FALSE);
	return hr;
}


// DllUnregisterServer - Removes entries from the system registry
STDAPI DllUnregisterServer(void)
{
	HRESULT hr = _AtlModule.DllUnregisterServer(FALSE);
	return hr;
}

